/*
 * Copyright (c) 2010, Boris Popov <popov.b@gmail.com>
 *
 * Permission to use, copy, modify, and/or distribute
 * this software for any purpose with or without fee
 * is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH
 * THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include "cstringakk.h"

/*---------------------------------------------------*/
StringAkk
InitStringAkk () {

	StringAkk akk;
	akk = (StringAkk) malloc (sizeof (struct _StringAkk));
	akk->string = NULL;
	return akk;
}

void
DestoryStringAkk (StringAkk sakk) {

	if (sakk != NULL) {

		if (sakk->string != NULL) {

			free (sakk->string);
		}

		free (sakk);
	}

	return;
}

void
AddByteToStringAkk (StringAkk sakk, Byte byte) {

	if (sakk == NULL) {

		return;
	}

	if (sakk->string == NULL) {

		Byte* newbyte = (Byte*) malloc (2);
		*(newbyte) = byte;
		*(newbyte + 1) = '\0';
		sakk->string = newbyte;
	}

	else {

		size_t len = strlen (sakk->string);
		Byte* newbyte = (Byte*) malloc ((len + 1) + 1);
		memset (newbyte, '\0', ((len + 1) + 1));
		strcpy (newbyte, (sakk->string));
		free (sakk->string);
		*(newbyte + len) = byte;
		sakk->string = newbyte;
	}
	return;
}

CString
GetStringFromStringAkk (StringAkk sakk) {
	
	if (sakk == NULL) {

		return "";
	}
	return sakk->string;
}
/*---------------------------------------------------*/
