/*
 * Copyright (c) 2010, Boris Popov <popov.b@gmail.com>
 *
 * Permission to use, copy, modify, and/or distribute
 * this software for any purpose with or without fee
 * is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH
 * THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string_common.h>
#include <stdlib.h>
#include <string.h>

#ifndef __cstringakk__h__
#define __cstringakk__h__

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------*/
typedef char Byte;
/*---------------------------------------------------*/

/*---------------------------------------------------*/
struct _StringAkk {

	Byte* string;
};
typedef struct _StringAkk* StringAkk;
/*---------------------------------------------------*/

/*---------------------------------------------------*/
StringAkk
InitStringAkk ();

void
DestoryStringAkk (StringAkk);

void
AddByteToStringAkk (StringAkk, Byte);

CString
GetStringFromStringAkk (StringAkk);
/*---------------------------------------------------*/

#ifdef __cplusplus
}
#endif

#endif
